#include "nrfx_timer.h"
#include "nrf_gpio.h"

#define NOP_COUNT (1000000) // Works if changed to 100000

const nrfx_timer_t timer_inst = NRFX_TIMER_INSTANCE(3);

void timer_irq(nrf_timer_event_t event_type, void* p_context)
{
}

int main(void)
{
    const nrfx_timer_config_t timer_config =
    {
        .frequency          = NRF_TIMER_FREQ_125kHz,
        .mode               = NRF_TIMER_MODE_TIMER,
        .bit_width          = NRF_TIMER_BIT_WIDTH_32,
        .interrupt_priority = 6,
        .p_context          = NULL
    };

    nrf_gpio_cfg_output(NRF_GPIO_PIN_MAP(0, 11));

    nrfx_timer_init(&timer_inst, &timer_config, timer_irq);
    nrfx_timer_extended_compare(&timer_inst, NRF_TIMER_CC_CHANNEL0, 125 * 100, NRF_TIMER_SHORT_COMPARE0_CLEAR_MASK, true); // 100 ms
    nrfx_timer_enable(&timer_inst);
    
    for (;;)
    {
        nrf_gpio_pin_toggle(NRF_GPIO_PIN_MAP(0, 11));

        for (uint32_t i = 0; i < NOP_COUNT; ++i)
            __NOP();

        nrfx_timer_disable(&timer_inst); // Disable the timer
        
        __WFE();
        // Clear the internal event register.
        __SEV();
        __WFE();

        nrfx_timer_enable(&timer_inst);

        nrf_gpio_pin_toggle(NRF_GPIO_PIN_MAP(0, 11));

        for (uint32_t i = 0; i < NOP_COUNT; ++i)
            __NOP();
    }
}